var Canvas = Class.create();

Canvas.prototype = {
  initialize: function(size, handler){
    this.createMode(handler);
    this.createCanvas(size, handler);
  },
  createMode: function(handler) {
    var draw = Element.create('div');
    var erase = Element.create('div');
    draw.innerHTML = 'draw';
    draw.addClassName('selected');
    draw.addClassName('mode');
    Event.observe(draw, 'click', function() {
      handler.mode = 'draw';
      draw.addClassName('selected');
      erase.removeClassName('selected');
    });
    document.body.appendChild(draw);
    erase.innerHTML = 'erase';
    erase.addClassName('mode');
    Event.observe(erase, 'click', function() {
      handler.mode = 'erase';
      erase.addClassName('selected');
      draw.removeClassName('selected');
    });
    document.body.appendChild(erase);
  },
  createCanvas: function(size, handler) {
    canvas = Element.create('div');
    canvas.addClassName('canvas');
    (size).times(function(x) {
      var row = Element.create('div');
      row.addClassName('row');
      (size).times(function(y) {
        new Canvas.Cell(handler, row, x, y);
      });
      canvas.appendChild(row);
    });
    document.body.appendChild(canvas);
    this.canvas = canvas;
  },
  find: function(x, y) {
    try {
      return this.canvas.childNodes[x].childNodes[y];
    }catch(e){}
  }
};

Canvas.Cell = Class.create();
Canvas.Cell.Methods = {
  draw: function() {
    if(!this.hasClassName('draw')) this.addClassName('draw');
  },
  erase: function() {
    if(this.hasClassName('draw')) this.removeClassName('draw');
  }
};

Canvas.Cell.prototype = {
  initialize: function(handler, row, x, y) {
    cell = Element.create('div');
    cell.addClassName('cell');
    cell.x = x;
    cell.y = y;
    this.functionRegister(cell);
    handler.register(cell);
    row.appendChild(cell);
  },
  functionRegister: function(cell){
    for (method in Canvas.Cell.Methods) {
      cell[method] = Canvas.Cell.Methods[method].bind(cell);
    }
  }
};
