#!/usr/bin/env ruby
require 'drb/drb'

class CometConnection
  def initialize(druby_uri = 'druby://localhost:10002', output = $stdout)
    @output = $stdout
    @output.sync = true
    drb_connect druby_uri
  end
  attr_accessor :output

  def drb_connect(druby_uri)
    DRb.start_service
    begin
      ts = DRbObject.new_with_uri(druby_uri)
      q = Queue.new
      ts.write [:push, Process.pid, DRbObject.new(q)]
      set_trap ts
    rescue
      sleep 0.5
      retry
    end

    output.write "Content-Type: text/plain\n\n"
    ary = q.deq
    output.write ary.inspect

    free ts
  end

  def free(ts)
    ts.take [:push, Process.pid, DRbObject]
  end

  private
  def set_trap(ts)
    trap(:SIGTERM) {
      free ts
      exit
    }
  end
end

CometConnection.new
