require 'irb'
require 'drb/drb'
require 'rinda/tuplespace'

class CometServer
  def initialize(druby_uri = 'druby://localhost:10002')
    @ts = Rinda::TupleSpace.new
    DRb.start_service(druby_uri, @ts)
    @ts.write [:comet_server, DRbObject.new(self)]
    @canvas = Array.new(8){Array.new(8){0}}
    @mutex = Mutex.new
    puts druby_uri
  end
  attr_accessor :canvas, :ts

  def draw(x, y, mode)
    case mode
    when 'draw'
      @canvas[x][y] = 1
    when 'erase'
      @canvas[x][y] = 0
    end
    push(@canvas)
  end

  def push(str)
    ts.read_all([:push, nil, nil]).map {|o| o[2] }.each do |q|
        @mutex.synchronize { q.enq(str) }
    end
    str
  end
end

module Kernel
  def c=(obj)
    @@__comet_push = obj
  end
  def c
    @@__comet_push
  end
  def push(obj)
    c.push obj
  end
  def canvas
    c.canvas
  end
end

Kernel.c = CometServer.new

IRB.start
