var MouseEventHandler = Class.create();
MouseEventHandler.prototype = {
  initialize: function(request_uri) {
    this.mode = 'draw';
    this.overClassName = 'mouseover';
    this.request_uri = request_uri;
  },
  register: function(cell) {
    for (var property in this) {
      var match = property.match(/^on([A-Z].*)/);
      if(match) {
         Event.observe(cell, match[1].toLowerCase(), this.bindCellEventListener(this, property, cell));
      };
    }
  },
  bindCellEventListener: function(handler, property, _cell) {
    return function(cell, event) {
      return handler[property].call(handler, _cell, event || window.event);
    }
  },
  draw: function(cell) {
    if(this.mode == 'draw') {
      cell.draw();
      this.request(cell);
    } else if(this.mode == 'erase'){
      cell.erase();
      this.request(cell);
    }
  },
  request: function(cell) {
    var uri = this.request_uri + '?' + $H({
      x: cell.x,
      y: cell.y,
      mode: this.mode
    }).toQueryString();
    new Ajax.Request(uri, { method: 'get' });
  },
  onMouseOver: function(cell) {
     cell.addClassName('mouseover');
  },
  onMouseDown: function(cell) {
     this.draw(cell);
  },
  onMouseOut: function(cell) {
    cell.removeClassName('mouseover');
  }
};

